const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const analytics_daily = sequelize.define(
    'analytics_daily',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      date: {
        type: DataTypes.DATE,
      },

      visits: {
        type: DataTypes.INTEGER,
      },

      clicks: {
        type: DataTypes.INTEGER,
      },

      top_referrers: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  analytics_daily.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.analytics_daily.belongsTo(db.profile_pages, {
      as: 'profile_page',
      foreignKey: {
        name: 'profile_pageId',
      },
      constraints: false,
    });

    db.analytics_daily.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.analytics_daily.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.analytics_daily.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return analytics_daily;
};
